Summary: OpenSSH free Secure Shell (SSH) implementation
Name: openssh
Version: 3.1p1
Release: 1
Group: Applications/Internet
Copyright: BSD
URL: http://www.openssh.com/
Packager: Hao Li <hli@haoli.org>
Source: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz
Patch0: ssh_config.patch
Patch1: sshd_config.patch
BuildRoot: /var/tmp/%{name}-root
Obsoletes: ssh, ssh1, ssh2
BuildPreReq: perl, openssl-devel, tcp_wrappers, pam

%description
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to separate libraries (OpenSSL).


%prep
%setup -q


%build
CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=/usr \
	--datadir=/usr/share/openssh \
	--sysconfdir=/etc/ssh \
	--with-pam \
	--with-tcp-wrappers \
	--with-ipv4-default \
	--with-rsh=/usr/bin/rsh \
	--with-default-path=/usr/local/bin:/bin:/usr/bin:/usr/games:/usr/X11R6/bin

# Force to link to static openssl because openssl keeps bringing in
# non-backward-compatible changes.
perl -pi -e "s|-lcrypto|/usr/lib/libcrypto.a|g" Makefile

make


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/etc/{pam.d,rc.d/init.d}
install -m644 contrib/redhat/sshd.pam-7.x $RPM_BUILD_ROOT/etc/pam.d/sshd
install -m755 contrib/redhat/sshd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sshd

# Patch config files to allow ssh-agent and X11 forwarding by default
cd $RPM_BUILD_ROOT/etc/ssh
patch --no-backup-if-mismatch ssh_config  %{PATCH0}
patch --no-backup-if-mismatch sshd_config %{PATCH1}


%post
/sbin/chkconfig --add sshd

%preun
if [ "$1" = 0 ] ; then
	/sbin/chkconfig --del sshd
fi


%files
%defattr(-,root,root)
%doc CREDITS ChangeLog INSTALL LICENCE OVERVIEW README README.smartcard
%doc RFC.nroff TODO WARNING.RNG
%dir /etc/ssh
%config /etc/ssh/*
%config /etc/pam.d/sshd
%config /etc/rc.d/init.d/sshd
/usr/bin/*
/usr/sbin/*
/usr/share/*
/usr/libexec/*
/usr/man/man*/*


%clean
rm -rf $RPM_BUILD_ROOT

